// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FMemberReference.h"
#include "ISCW_UFunction.h"
#include "ISCW_UK2Node.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UEdGraph;

	class ISCW_UK2Node_CallFunction : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_CallFunction() = default;

		virtual shared_ptr<ISCW_UEdGraph> GetFunctionGraph() const = 0;

		virtual ISCW_FMemberReferencePtr GetFunctionReference() const = 0;

		virtual ISCW_UFunctionPtr GetTargetFunction() const = 0;

		virtual void SetFromFunction(ISCW_UFunctionConstPtr Function) = 0;
		
		virtual shared_ptr<ISCW_UK2Node_CallFunction> ToUK2Node_CallFunctionPtr() = 0;
		virtual shared_ptr<const ISCW_UK2Node_CallFunction> ToUK2Node_CallFunctionPtr() const = 0;
	};

	using ISCW_UK2Node_CallFunctionConstPtr = shared_ptr<const ISCW_UK2Node_CallFunction>;
	using ISCW_UK2Node_CallFunctionPtr = shared_ptr<ISCW_UK2Node_CallFunction>;
} // namespace Sourcify